﻿# Начало работы со Снегопатом
Это небольшая статья, которая поможет вам быстрее начать использовать снегопат и подскажет
первые действия по его настройке и возможностям.

При первом запуске в Конфигураторе вам открылось основное окно снегопата. В нем вы можете:
  
- управлять аддинами - загрузка, выгрузка, состав запуска при старте.
- выполнять макросы.
- настраивать встроенные возможности снегопата
- настраивать хоткеи
- просматривать справку
- просматривать информацию о снегопате

Открыть снова это окно в случае его закрытия можно с помощью макроса
`Служебные аддины\Снегопат\Открыть окно Снегопата`.

---

Основные понятия снегопата, которыми он оперирует, это - встроенные возможности самого снегопата, макросы,
хоткеи и аддины.

<dl>
<dt>Аддин</dt>
<dd>Программный модуль к снегопату, реализующий некий дополнительный функционал.
Основными аддинами являются скрипты на JScript, хотя возможны и другие виды аддинов.
</dd>
<dt>Макрос</dt>
<dd>Команда, выполняющая некие действия, предоставляемая снегопатом или каким-либо аддином</dd>
<dt>Хоткей</dt>
<dd>Комбинация нажатия клавиш, которая назначается на вызов макроса.</dd>
</dl>

---

Часть возможностей снегопата активируется самостоятельно. Однако бо&#769;льшая часть функциональности
доступна посредством вызова макросов. Состав макросов в снегопате зависит от загруженных аддинов.
Стоит отметить, что большая часть функционала самого снегопата сама реализована с помощью встроенных аддинов.

Макрос выполняется его выбором из окна макросов, которое вызывается нажатием `Ctrl + M`.
Это стандартный хоткей, который не переопределяется и всегда такой. Кроме того, окно
макросов может быть открыто из окна снегопата, с вкладки "Аддины", из командной панели командой
`Выполнить макрос...`. И наконец, вызов окна макросов сам осуществляется с помощью макроса:
`Служебные аддины\Снегопат\ВыбратьИВыполнитьМакрос`.
Макрос может быть вызван и напрямую, без окна макросов, путём назначения для него хоткея.

Состав используемых аддинов задается на вкладке "Аддины" окна снегопата. На вкладке
**"Работающие аддины"** показано дерево текущих выполняющихся аддинов. Они в-основном сгруппированы
в три основные группы:

- **Служебные аддины**. Это аддины, которые нужны для работы самого снегопата. Они загружаются
  автоматически, их состав пользователем не изменяется, выгрузить и перезагрузить их нельзя,
  загрузить дополнительные аддины в эту группу нельзя.
- **Подгружаемые библиотеки**. Это аддины, которые предоставляют некоторую общую функциональность
  для других аддинов, и которые загружаются "по требованию", если они понадобились другим
  загружаемым аддинам. Их также нельзя выгрузить/перезагрузить, либо загрузить аддин в эту группу.
- **Пользовательские аддины**. Это именно та группа, состав которой определяется пользователем.
  Именно вы задаете, какие дополнительные аддины загружать здесь при старте, можете вручную
  загрузить при необходимости сюда аддины, выгрузить или перезагрузить аддины, которые
  поддерживают такую возможность. В большинстве случаев, состав используемых вами аддинов
  определяется вами довольно быстро, и в дальнейшем вы редко будете здесь что-либо исправлять.

Для загрузки аддина "на лету", необходимо встать на саму группу "Пользовательские аддины" или группу
в ее пределах, и выбрать команду `Аддины\Загрузить ххх`, или выбрать команду загрузки из контекстного
меню. Состав видов загружаемых аддинов зависит от подключенных к снегопату загрузчиков аддинов.
Сам снегопат поддерживает загрузку скриптов и dll, однако другие аддины могут реализовать и
дополнительные загрузчики.

В правой части вкладки "Аддины" показывается репозитарий аддинов. Это аддины, которые вы можете
подключать к снегопату. Если аддин уже загружен, он отображается зеленым цветом. При выборе
аддина внизу показывается справочная информация о нём, при ее наличии. Отображается только первая
страница справки по аддину. Для просмотра полной справки можно нажать кнопку "Найти в справке"
над окном описания аддина. Репозитарий аддинов состоит из двух частей - "Официальные" и "Пользовательские".
Официальные поставляются вместе с снегопатом и расположены в каталоге addins.
Пользовательский репозитарий ищется в каталоге custom. Туда можно складывать свои разработки, либо
разработки других авторов, не входящие в официальный репозитарий.

На вкладке **"Список загрузки аддинов"** вы можете изменять состав загружаемых при старте снегопата
аддинов. Для этого выберите в левой части группу, в которую желаете поместить аддин, в правой части
желаемый аддин, и нажмите `Enter` или выполните команду `Подключить аддин`.

Команда `Подключить аддин` действует по разному, в зависимости от того, какая вкладка открыта
в левой части. Если открыт список работающих аддинов, команда загрузит аддин на выполнение.
Если открыт список загрузки аддинов, команда поместит аддин в список загружаемых при старте,
без его запуска.

После редактирования списка загружаемых аддинов - не забудьте его сохранить.

Группировка аддинов в списке влияет на их расположение в окне макросов.

**Сведения о вкладке "Настройка" и других вкладках располагаются в подразделах этой статьи и доступны
в справочной системе. Перейти к ней вы можете, нажав "Найти в справке"**

## Вкладка Настройка
На этой вкладке можно настроить встроенные возможности снегопата, те, которые работают без аддиннов
и вызова макросов.

- Работать при наборе текста  
    При включении снегопат внедряется в работу редактора модулей, следя за нажатиями клавиш.
    -  Использовать список снегопата  
        при включении снегопат может выдавать подсказки о наборе текста в виде списка продолжений
        слов. Список может появлятся как автоматически при наборе, так и вызываться принудительно,
        по-умолчанию нажатием `Ctrl + Alt + Пробел`. Помимо умного составления содержимого списка,
        он предоставляет еще несколько удобств: текущее слово в списке всегда показывается полностью,
        список не прокручивается на первое совпадение, а фильтруется, уменьшаясь в размерах,
        слова, недавно выбирающиеся из списка, размещаются в его начале, поиск осуществляется
        с учётом возможной неправильной раскладки клавиатуры, есть возможность поиска по вхождению
        частей слова, можно набирать только заглавные буквы искомого слова, не блокирует выполнение
        других команд текстового редактора, типа `Ctrl+Z`, `Ctrl+V` и т.п.
        - Ширина списка  
            Задает ширину списка снегопата в пикселях. Независимо от ширины списка,
            текущее слово в нём всегда показывается полностью.
        - Символов для авто-активации  
            Задает количество символов в слове, после набора которых
            подсказка снегопата появляется автоматически. При указании 0 - автоактивация отключается,
            и список можно вызвать только принудительно.
        - Разрешить фильтрацию в списке снегопата при нажатии Shift+Пробел  
            При включении, когда вы набирате текст при открытом списке снегопата и нажимаете
            `Shift + Пробел`, список переходит в режим "фильтрации по вхождению".
            Если в обчном режиме в списке остаются те слова, которые **начинаются** с набранных символов, то
            в этом режиме в списке остаются слова, которые **содержат** набранные символы. При этом таких
            частей слов для проверки вхождения может быть несколько, разделенных пробелом.
            Остаются те слова, которые содержат все эти части. Удобно для быстрой фильтрации в словах, которые
            содержат длинное одинаковое начало, и различаются только окончанием. 
        - Использовать языки: Русский, Английский  
            Задает использование языков для названий встроенных методов,
            свойств, ключевых слов. Хотя-бы один язык должен всегда быть включен.
    - Автозамены (++, -- и т.п.)  
        Включает выполнение автоматических замен при наборе выражений вида

            имя++ -> имя=имя+1
            имя-- -> имя=имя-1
            имя+= -> имя=имя+
            имя-= -> имя=имя-
            имя*= -> имя=имя*
            имя/= -> имя=имя/
            имя%= -> имя=имя%
        Если между именем и символами оставить пробел, он также добавится и при замене, `имя ++ -> имя = имя + 1`
    - Умный Enter  
        Включает дополнительную обработку нажатия Enter'а. Если нажатие происходит внутри
        строкового литерала, без завершающей кавычки, то в начале следующей строки будет вставлен
        символ `|`. Если же нажатие произошло в конце комментария, и нажат `Shift`, автоматически будет
        вставлено `//`.
- Пользовательские группировки  
    При включении настройки в редакторе модуля можно использовать специальные комментарии для задания
    поизвольных сворачивающихся блоков текста. Для отметки начала блока используется комментарий,
    начинающийся с `//{`, для пометки конца блока - комментарий `//}`. Сам снегопат блоки не группирует,
    а только "обманывает" редактор 1С, выдавая ей эти комментарии за другие слова. До 8.3.5 это слова
    `Процедура` и `КонецПроцедуры`, после - `#Область` и `#КонецОбласти`. Соответственно, эти группировки
    должны быть включены в настройках 1С.
- Раскрашивать многострочные литералы как запросы  
    При включении снегопат начинает использовать для раскраски многострочных строк расширение
    поля текстового документа "Язык запросов", вместо "Встроенный язык".
    - Изменять цвет фона  
      При включении дополнительно раскрашивается фон многострочных строк.
    - Цвет фона  
      Задает цвет для раскраски фона многострочных строк.
- Перехват штатного списка с подсказками  
    При включении, когда 1С собирается показать свой список контекстной подсказки, снегопат перехватывает
    это событие, получает содержимое списка 1С и вместо штатного списка 1С показыват это содержимое в своем
    списке, пользоваться которым более удобно.
- Убирать символы `//:` при разборе модуля штатной подсказкой  
    При включении, когда штатная подсказка анализирует текст модуля для построения списка контекстной подсказки,
    снегопат убирает из текста модуля символы `//:`. Таким образом, во время анализа 1С считает такие
    комментарии кодом и анализирует их. Это позволяет делать "ручную типизацию" для работы контекстной
    подсказки "после точки". Например:

        Функция Некоторая Функция(Док, Таблица)
            //: Док = Документы.ВозвратМатериаловИзЭксплуатации.ПолучитьСсылку()
            Док. < тут выдаст методы и свойства ДокументСсылка.ВозвратМатериаловИзЭксплуатации
            //: Таблица = Новый ТабличныйДокумент
            Таблица. < тут выдаст методы и свойства типа ТабличныйДокумент

## Справочная система снегопата
Справка к снегопату строится "на месте", локально, из текстовых файлов, которые преобразуются в html
файлы и отображаются в окне снегопата с помощью ПоляHtmlДокумента. Файлы создаются в папке help папки
снегопата. Также там создается файл базы данных help.db, в которой снегопат хранит сведения о
преобразованных файлах, составе их разделов, а также индекс полнотектового поиска по справке.
При возникновении проблем папку help можно удалить, она перестроится заново при следующем
запуске снегопата.

Для поиска по справке применяется полнотекстовый поиск базы данных sqlite. Помимо поиска по целым
словам он также поддерживает поиск по начальным частям слов, в этом случае в конце части слова
дописывается `*`.  